<?php
/**
 * montonio/module-hire-purchase
 *
 * @category   montonio
 * @package    module-montonio-m1
 * @copyright  Copyright (c) 2021 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */

/**
 * @inheritdoc
 */
class Montonio_Gateway_Block_Payments_Methods extends Mage_Checkout_Block_Onepage_Payment_Methods
{

    /**
     * @inheritdoc
     */
    public function getPaymentMethodFormHtml(Mage_Payment_Model_Method_Abstract $method)
    {
        //for virtual items those do not exist and have to be created
        if (strstr($method->getCode(), 'montonio_payments_')) {
            $alias      = 'payment.method.' . $method->getCode();
            $childBlock = $this
                ->getLayout()
                    ->createBlock(
                        $method->getFormBlockType(),
                        $alias
                    );
            $this->setChild(
                $alias,
                $childBlock->setMethod($method)
            );
        }
        if (strstr($method->getCode(), 'montonio_split')) {
            $alias      = 'payment.method.' . $method->getCode();
            $childBlock = $this
                ->getLayout()
                ->createBlock(
                    $method->getFormBlockType(),
                    $alias
                );
            $this->setChild(
                $alias,
                $childBlock->setMethod($method)
            );
        }
        return parent::getPaymentMethodFormHtml($method);
    }
}
